VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7035
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   7035
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid flxFonts 
      Height          =   1095
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2775
      _ExtentX        =   4895
      _ExtentY        =   1931
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" (ByVal hdc As Long, lpMetrics As TEXTMETRIC) As Long
Private Type TEXTMETRIC
    tmHeight As Long
    tmAscent As Long
    tmDescent As Long
    tmInternalLeading As Long
    tmExternalLeading As Long
    tmAveCharWidth As Long
    tmMaxCharWidth As Long
    tmWeight As Long
    tmOverhang As Long
    tmDigitizedAspectX As Long
    tmDigitizedAspectY As Long
    tmFirstChar As Byte
    tmLastChar As Byte
    tmDefaultChar As Byte
    tmBreakChar As Byte
    tmItalic As Byte
    tmUnderlined As Byte
    tmStruckOut As Byte
    tmPitchAndFamily As Byte
    tmCharSet As Byte
End Type
Private Const FIXED_PITCH = 1
' Size the columns in this control to fit the data.
Private Sub SizeColumns(ByVal flx As MSFlexGrid)
Dim r As Integer
Dim c As Integer
Dim col_wid As Single
Dim max_wid As Single

    ' Use the same font used by the FlexGrid.
    Font.Name = flx.Font.Name
    Font.Bold = flx.Font.Bold
    Font.Italic = flx.Font.Italic
    Font.Underline = flx.Font.Underline
    Font.Size = flx.Font.Size
    Font.Strikethrough = flx.Font.Strikethrough

    ' Size each column.
    For c = 0 To flx.Cols - 1
        ' Find the widest string in this column.
        max_wid = 0
        For r = 0 To flx.Rows - 1
            col_wid = TextWidth(flx.TextMatrix(r, c))
            If max_wid < col_wid Then max_wid = col_wid
        Next r
        flx.ColWidth(c) = max_wid + 120
    Next c

    ' Sort on the name column.
    flx.Col = 0
    flx.Sort = flexSortGenericAscending
End Sub
Private Sub Form_Load()
Dim i As Long
Dim font_name As String
Dim tm As TEXTMETRIC

    flxFonts.AllowUserResizing = flexResizeColumns
    flxFonts.Rows = Screen.FontCount + 1
    flxFonts.FixedRows = 1
    flxFonts.Cols = 2
    flxFonts.TextMatrix(0, 0) = "Font Name"
    flxFonts.TextMatrix(0, 1) = "Pitch"

    For i = 0 To Screen.FontCount - 1
        ' Select the font.
        font_name = Screen.Fonts(i)
        Font.Name = font_name
        flxFonts.TextMatrix(i + 1, 0) = font_name

        ' Get the font's metrics.
        GetTextMetrics hdc, tm

        ' See if it is fixed width.
        If (tm.tmPitchAndFamily And FIXED_PITCH) = 0 Then
            flxFonts.TextMatrix(i + 1, 1) = "Fixed"
        Else
            flxFonts.TextMatrix(i + 1, 1) = "Variable"
        End If
    Next i

    SizeColumns flxFonts
End Sub
Private Sub Form_Resize()
    flxFonts.Move 0, 0, ScaleWidth, ScaleHeight - 240
End Sub


